/* $Id: OzListTest.c,v 1.1 2011/09/26 00:42:44 leavens Exp leavens $
   AUTHOR: Gary T. Leavens */
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "OzList.h"
static long length(OzList const * ls) {
  long count = 0L;
  while (!isEmpty(ls)) {
    count++;
    ls = tail(ls);
  }
  return count;
}
/* test data */
typedef struct {int data;} *Integer;
static Integer Three; static Integer Maxwell; static Integer NN;

int main(int argc, char **argv) {
  printf("OzListTest $Revision: 1.1 $\n");
  Three = malloc(sizeof(Integer));
  Maxwell = malloc(sizeof(Integer));   NN = malloc(sizeof(Integer));
  Three->data = 3;  Maxwell->data = 86;  NN->data = 99;
  printf("test of empty list\n");
  OzList const * myLs = newOzEmptyList();
  assert (isEmpty(myLs));
  assert (length(myLs) == 0);
  printf("test of 1 element list\n");
  OzList const * ls = newOzEmptyList();
  ls = cons(Three, ls);
  assert (length(ls) == 1);
  assert (head(ls) == Three);
  assert (isEmpty(tail(ls)));
  printf("test of 2 element list\n");
  OzList const * ls2 = cons(NN, ls);
  assert (length(ls2) == 2);
  assert (length(ls) == 1);
  assert (head(ls2) == NN);
  assert (head(tail(ls2)) == Three);
  assert (length(ls2) == 2);
  printf("test of 3 element list\n");
  OzList const * ls3 = cons(Maxwell, ls2);
  assert (length(ls3) == 3);
  assert (head(ls3) == Maxwell);
  assert (head(tail(ls3)) == NN);
  assert (length(ls2) == 2);
  assert (length(ls) == 1);
  printf("test of string lists\n");
  OzList const * lss = newOzEmptyList();
  lss = cons("first", lss);
  assert (length(lss) == 1);
  assert (head(lss) == "first");
  assert (isEmpty(tail(lss)));
  OzList const * newLs = lss;
  newLs = cons("second", lss);
  assert (length(lss) == 1);
  assert (head(lss) == "first");
  assert (isEmpty(tail(lss)));
  assert (length(newLs) == 2);
  assert (head(newLs) == "second");
  assert (head(tail(newLs)) == "first");
  printf("done\n");
  return 0;
}
