// $Id: OzListTest.java,v 1.3 2011/10/04 00:59:57 leavens Exp leavens $

public class OzListTest {
    /** Return the length of the argument list. */
    public static <T> long length(OzList<T> ls) {
        long count = 0L;
        while (!ls.isEmpty()) {
            count++;
            ls = ls.tail();
        }
        return count;
    }

    public static void checkAssertionsOn() {
        try {
            assert false;
        } catch (java.lang.AssertionError e) {
            // OK!
            return;
        }
        System.err.println("You need to run java with the -ea flag to turn assertions on!");
        System.exit(1);
    }

    /** Testing code. */
    public static void main(String [] argv) {
        System.out.println("OzListTest $Revision: 1.3 $");
        System.out.println("test of empty list");
        checkAssertionsOn();
        OzList<Integer> myLs = new OzEmptyList<Integer>();
        assert myLs.isEmpty();
        assert length(myLs) == 0;

        System.out.println("test of 1 element list");
        OzList<Integer> ls = new OzEmptyList<Integer>();
        ls = new OzCons<Integer>(3, ls);
        assert length(ls) == 1;
        assert ls.head() == 3;
        assert ls.tail().isEmpty();

        System.out.println("test of 2 element list");
        OzList<Integer> ls2 = new OzCons<Integer>(99, ls);
        assert length(ls2) == 2;
        assert length(ls) == 1;
        assert ls2.head() == 99;
        assert ls2.tail().head() == 3;
        assert length(ls2) == 2;

        System.out.println("test of 3 element list");
        OzList<Integer> ls3 = new OzCons<Integer>(86, ls2);
        assert length(ls3) == 3;
        assert ls3.head() == 86;
        assert ls3.tail().head() == 99;
        assert length(ls2) == 2;
        assert length(ls) == 1;

        System.out.println("test of string lists");
        OzList<String> lss = new OzEmptyList<String>();
        lss = new OzCons<String>("first", lss);
        assert length(lss) == 1;
        assert lss.head().equals("first");
        assert lss.tail().isEmpty();
        OzList<String> newLs = lss;
        newLs = new OzCons<String>("second", lss);
        assert length(lss) == 1;
        assert lss.head().equals("first");
        assert lss.tail().isEmpty();
        assert length(newLs) == 2;
        assert newLs.head().equals("second");
        assert newLs.tail().head().equals("first");
        System.out.println("done");
    }
}
